/*************************************************************************************************************/
/****  Carpeta / tipo contenido ******************************************************************************/
/*************************************************************************************************************/

//inits
def tipoYaSeteado=false
def prodCountries=info.ProductionCountries
def certifications=info.Certifications
def pais = {try{country} catch (err) {null}}()
def numPaises = prodCountries.size()
def llengu = {try {def langs=[]; for (lan in languages) langs.add(lan.toString()); return langs } catch(err) {[]}}()
def audioLlengu = {try {def langs=[]; for (lan in audioLanguages) langs.add(lan.toString()); return langs } catch(err) {[]}}()
def soloLangIngles = llengu.size()==1 && llengu[0]=="eng"

//animacion (no concluyente)
def fakeAnimacionList = ["blue & malone", "cool world"]
def tieneAnimacion = genres.any{ it =~ /Anima.i.n/} && !fakeAnimacionList.any{localize.English.n.toLowerCase().contains(it)}
//familiar (no conclud)
def tieneFamiliar = genres.any{ it =~ /Familia|Family/}
//docu
def esDocu = genres.any{ it =~ /Documental|Documentary|Reality/} && !(localize.English.n =~ /Jackass/)
//Anime ---------- (Animacion encara no es pot perquè depen del infantil)
def esAnime = false
if (tieneAnimacion && prodCountries.contains("JP") && (!llengu.isEmpty() ? llengu.contains('jpn') : true)) {
	esAnime = (numPaises==1 || anime || pais=="JP") 
	&& ["nemo"].any{!localize.English.n.toLowerCase().contains(it)}
}
tipoYaSeteado = esDocu || esAnime

//***** familiar vs infantil ****
def esFamiliar = tieneFamiliar
def	infantil = false

if (!tipoYaSeteado) {
	def tieneCertificacion = certifications!=null && certifications.size()!=0
	def detectadoNoInfantil = tieneCertificacion && (
				(certifications.US!=null && certifications.US==~/PG-13|R/)
			||	(certifications.ES!=null && certifications.ES==~/16|18/))

	if (detectadoNoInfantil) infantil=false
	else if (tieneFamiliar && tieneAnimacion) infantil=true
	else if (tieneAnimacion) {
		if (tieneCertificacion) {
				infantil = (certifications.US!=null ? certifications.US!="R" : true) &&
					(certifications.US=="G"
					|| certifications.ES==~/Ai|APTA/
					|| certifications.DE==~/0/
					|| certifications.IT=="T" 
					|| certifications.IE=="G" 
					|| certifications.LT=="V" || certifications.RU ==~ /6.+/
					|| certifications.BR=="L"
					|| certifications.NO=="A"
					|| certifications.FR=="U")
		} else {
			def titulosInfantiles = ['boonie bears', 'the jungle bunch']
			if (titulosInfantiles.any { localize.English.n.toLowerCase().contains(it) })
				infantil = true
		}
	} else if (!esFamiliar && false) { //em posa pelicules que no toquen
		if (tieneCertificacion && (
				certifications.US=="G"
			)) {
			esFamiliar = true //posem a familiar pelis de nens que no son animacio
		}
	}
	tipoYaSeteado = tipoYaSeteado || infantil
}

//animacion
def esAnimacion = tieneAnimacion && !infantil
tipoYaSeteado = tipoYaSeteado || esAnimacion

//***  española / catalana ***
def catalana = false
def espanyola = false
if (!tipoYaSeteado && (numPaises>0 ? prodCountries.contains("ES") : true)) {
	catalana = llengu.contains('cat')
	if (!catalana) {
		espanyola =
				(numPaises==1 || (numPaises==2 && prodCountries.any{ it=~/AR|PT/ }))
			||	{ try { info.Network =~ /(?i)\bFLIXOL.\b|\b.?TVE\b/ } catch (e) { false } }()
			||	({ try { info.ProductionCompanies.any{it =~ /.?TVE|ESDIP|Canal Sur|Canal\+|Telecinco/}}catch(e){false}}() && (llengu.size()==1?llengu[0]=="spa":true))
			||	(certifications.size()==1 && certifications.ES!=null) 
			||	((llengu.size()==1 && llengu[0]=="spa") || (llengu.size()==2 && llengu.contains("spa")))
			||	(movie.alternativeTitles.size()==1 && movie.alternativeTitles.ES!=null)
			||	(pais=="ES" && (!llengu.isEmpty() ? llengu.size()==1 && llengu[0]=="spa" : true))
	}
	tipoYaSeteado = tipoYaSeteado || espanyola || catalana
}

//asiaticas
def asiatica = false
if (!tipoYaSeteado && !soloLangIngles) {
	def paisesAsiaticos = ["CN", "HK", "JP", "KP", "KR", "TH", "NP", "TW", "PH", "MO", "SU"]
	def paisesIntersec=0
	def languajAsia = ["zho", "kor", "thai", "vie", "jpn", "ind", "rus"]
	def machingLanguages = languajAsia.intersect(llengu).size()
	asiatica = machingLanguages == languajAsia.size()
			|| paisesAsiaticos.any{ pais==it }
			|| (numPaises != 0 && {((paisesIntersec=paisesAsiaticos.intersect(prodCountries).size()) == numPaises || (/*en observacion*/paisesIntersec!=0 && !llengu.contains('eng')) ) }())
			|| (languajAsia.any{audioLlengu.contains(it)} && prodCountries.any{paisesAsiaticos.contains(it)} && llengu.any{languajAsia.contains(it)} )
			|| {try {director.contains("Takeshi Kitano")} catch (e) {false}}()
			|| (machingLanguages > 0 && primaryTitle!=null && localize.English.n!=primaryTitle)
		
	tipoYaSeteado = tipoYaSeteado || asiatica
}


//***  latina ***
def latina = false
if (!tipoYaSeteado && !soloLangIngles) {
	def paisesLatinos = ["MX", "AR"]
	latina = {try {paisesLatinos.contains(pais)} catch (e) {false}}()
			|| (numPaises != 0 && paisesLatinos.intersect(prodCountries).size() == numPaises)
			|| info.ProductionCompanies.any{it=~/Corazón Films/}
}
